
Redmine - Defect #7335

Sorting issues in gantt by date, not by id

2011-01-15 00:28 - Eli Stevens

Status: Closed Start date: 2011-01-15

Priority: Normal Due date:  

Assignee: Toshi MARUYAMA % Done: 90%

Category: Gantt Estimated time: 0.00 hour

Target version: 2.4.0   

Resolution: Fixed Affected version: 1.1.0

Description

I can't tell if the prior issues (see below) related to gantt chart issue sorting are about new- or old-style gantt charts.  I do know that

the default 1.1.0 isn't very useful, since they're sorted by root_id (ie. parent issue id).  That has little relation to the order that the

issues need to be worked on in.  I made a one-line change that worked for me:

1. TODO: top level issues should be sorted by start date

def gantt_issue_compare(x, y, issues)

[(x.root.start_date or x.start_date or Date.new()), (x.start_date or Date.new()), x.root_id, x.lft] <=> [(y.root.start_date or

y.start_date or Date.new()), (y.start_date or Date.new()), y.root_id, y.lft]

#if x.root_id == y.root_id   #  x.lft <=> y.lft

#else   #  #x.root_id <=> y.root_id

#end

end

I'm not 100% certain if it works in all cases, but for my DB (multi-project, multi-version, single nesting level issues), it works fine.

Related issues:

Related to Redmine - Patch #5438: Patch repairing rendering of subtasks in ga... Closed 2010-05-04 2010-05-04

Related to Redmine - Patch #7456: Gantt filters New 2011-01-26

Related to Redmine - Feature #6276: Gantt Chart rewrite Closed 2010-09-03

Related to Redmine - Patch #12730: Fix sorting and PDF output of Gantt diagra... New

Related to Redmine - Defect #7128: New gantt chart does not render subtasks u... Closed 2010-12-18

Related to Redmine - Feature #8897: Be able to reorder tasks/issues in the Ga... New 2011-07-25

Related to Redmine - Defect #7579: Gantt tab gives internal error. Closed 2011-02-08

Related to Redmine - Feature #14397: Gantt sorting as a configurable setting New

Has duplicate Redmine - Feature #7968: Order tasks by time on Gannt Closed

Has duplicate Redmine - Defect #8480: gantt sorting in redmine 1.2 Closed 2011-05-31

Has duplicate Redmine - Feature #13238: Sorting in Gantt Closed

Has duplicate Redmine - Defect #6968: Sorting of issues in Gantt Closed 2010-11-24

Has duplicate Redmine - Defect #8366: Gantt Version Ordering Closed 2011-05-13

Associated revisions

Revision 11724 - 2013-04-19 07:14 - Toshi MARUYAMA

add TODO comment about gantt issues sort (#7335)

Sorting by date was dropped by r4581 (#7128).

Revision 11769 - 2013-05-03 00:44 - Toshi MARUYAMA

Merged r11724 from trunk to 2.3-stable.

Add TODO comment about gantt issues sort (#7335).

Sorting by date was dropped by r4581 (#7128).

Revision 11855 - 2013-05-18 00:59 - Toshi MARUYAMA

gantt: change sort method to class method (#7335)
Revision 11856 - 2013-05-18 00:59 - Toshi MARUYAMA

gantt: add test to sort issues by current logic (#7335)

Revision 11897 - 2013-05-21 15:42 - Toshi MARUYAMA

gantt: sort issues by start date (#7335)

Revision 11898 - 2013-05-21 15:42 - Toshi MARUYAMA

gantt: sort versions by start date (#7335)

Revision 12247 - 2013-11-09 09:54 - Jean-Philippe Lang

Gantt: sort versions like on the roadmap (#7335).

History

#1 - 2011-01-15 00:29 - Eli Stevens

Hum, apparently I can't add related issues.  They should be:

#5438

#6968

#2 - 2011-01-17 15:33 - Guillaume Pellegrin

Hi Eli,

And thanks for your patch. Worked fine for me. I'll post here in case this breaks some use cases.

Hope this change will be made available in the next release.

Regards,

Guillaume

#3 - 2011-01-19 19:16 - Eli Stevens

Update: the first line didn't work in all cases for me.  This one seems to be behaving better:

[(x.root.start_date or x.start_date or Date.new()), x.root_id, (x.start_date or Date.new()), x.lft] <=> [(y.ro

ot.start_date or y.start_date or Date.new()), y.root_id, (y.start_date or Date.new()), y.lft]

#4 - 2011-01-25 12:27 - Sebastian Buckpesch

Hi,

where do I enter this line of code or apply this patch?

Thanks,

Sebastian

#5 - 2011-01-25 14:13 - Etienne Massip

lib/redmine/helpers/gantt_helper.rb (gantt_issue_compare()) ?

#6 - 2011-01-25 14:45 - Sebastian Buckpesch

thanks. Works fine.

#7 - 2011-01-25 22:47 - E M

Anyone knows if we can also sort by name? Or if the above patch could be easily modified to sort by top level issue name (instead of id like current or

start date like this fix)?

feel free to move this to a new issue if you feel it's necessary.

#8 - 2011-02-17 19:59 - Fernando Hartmann

+1

#9 - 2011-02-23 11:40 - Carlos Serrano

thanks. Works fine.

#10 - 2011-03-23 15:05 - Cassiano Monteiro

+1

#11 - 2011-08-16 23:28 - Lukas Elmer
+1, related with #8480

#12 - 2011-12-05 20:03 - Felipe Ribeiro

- File sort_issues_from_start_date.diff added

- File sort_issues.rb added

I solved this by changing the way to insert issues in the Data Base. I just insert them already in the correct order.

But also I had to change the values of rgt and lft directly on the Data Base, because there were projects already inserted in the system, and doing this

I guarantee that all projects will be sorted correctly.

Is attached the diff file and the new script i had to create.

#13 - 2012-03-08 18:20 - Svein-Tore Griff With

+1

#14 - 2012-03-10 13:33 - lmerl andeson

- Assignee set to Mischa The Evil

#15 - 2012-10-23 00:48 - Toshi MARUYAMA

- Assignee deleted (Mischa The Evil)

#16 - 2012-10-24 15:32 - Toshi MARUYAMA

- File redmine-trunk-r10713.png added

- File redmine-trunk-r10713-patch.png added

- File gantt-sort-r10713.diff added

This is a patch for trunk r10713.

This patch sort start date algorism is referred from Redmine Better Gantt Chart Plugin

https://github.com/kulesa/redmine_better_gantt_chart/blob/50c323fe8b6ac667c88b/lib/redmine/helpers/better_gantt.rb#L692

But, issues tree structure is broken by start date sorting.

Redmine trunk r10713

 

 

Patch applied

 redmine-trunk-r10713-patch.png  

#17 - 2012-10-24 19:16 - Etienne Massip

FTR the patch in #7456 originally implemented some sorting too.

#18 - 2013-01-05 05:39 - Jonathan Vargas

Hi guys.

I just required the sort by start date and then applied manually the first chunk mentioned on sort_issues_from_start_date.diff, to my 2.2.0 version, and

it worked as expected.

So, could it be possible to apply it on 2.2's trunk or next versions? I see that a default sorting by start_date first has more sense than by issue_id.

Thanks in advance.

#19 - 2013-01-05 09:30 - Toshi MARUYAMA

New patch is posted at #8366#note-2.

#20 - 2013-03-31 08:51 - Toshi MARUYAMA
- File gantt-sort-trunk-r11692.diff added

- File gantt-sort-trunk-r11692.png added

I confirmed #8366 Change-Gantt-default-sorting-to-start_date-instead-of-id.patch fixes note-16 problem.

I re-post it as gantt-sort-trunk-r11692.diff .

 

#21 - 2013-04-19 04:26 - Yuhki ISHIGURO

Thank you for your patch, Toshi.

I applied your patch, and it looked working correctly, first.

However, note-16 problem is still happen to issues which added

after your patch applied.

#22 - 2013-04-19 07:03 - Toshi MARUYAMA

- File gantt-sort-trunk-r11723.diff added

Yuhki Ishiguro wrote:

Thank you for your patch, Toshi.

I applied your patch, and it looked working correctly, first.

However, note-16 problem is still happen to issues which added

after your patch applied.

 Thank you for your trying.

Could you try this patch using another logic.

This logic is from here (in Japanese).

http://d.hatena.ne.jp/itto100pen/20121202

#23 - 2013-04-22 03:08 - Yuhki ISHIGURO

- File gantt.jpg added

Umm...  I tried new patch. And, same things happen.

I show you my Test project.

426 wasn't added correctly, but after adding 428, it was solved.

 gantt.jpg 

#24 - 2013-04-22 09:34 - Toshi MARUYAMA

- File gantt-sort-trunk-r11740.diff added

I got a suggestion from patch author.

https://twitter.com/nobu_toyofuku/status/326227862808064000

Could you try this patch?

#25 - 2013-04-22 09:54 - Yuhki ISHIGURO

I tried gantt-sort-trunk-r11740.diff, and it seems working correctly!

Thank you !!

Regards,

Yuhki ISHIGURO

#26 - 2013-04-23 17:45 - Toshi MARUYAMA
- File gantt-sort-trunk-r11744.diff added

gantt-sort-trunk-r11740.diff does not sort root issues.

This patch fixes it.

#27 - 2013-04-25 04:37 - Yuhki ISHIGURO

Toshi MARUYAMA wrote:

gantt-sort-trunk-r11740.diff does not sort root issues.

This patch fixes it.

 I greatly appreciate for you contribution.

I tried your new patch gantt-sort-trunk-r11744.

It works fine, and I think it solves this issue.

Regards,

Yuhki ISHIGURO

#28 - 2013-05-01 17:12 - David Dupont

Hi,

I tried to apply patch but errors occured :

root@linus:/var/www/redmine# patch -p0 < gantt-sort-trunk-r11744.diff

patching file b/lib/redmine/helpers/gantt.rb

Hunk #1 FAILED at 675.

1 out of 1 hunk FAILED -- saving rejects to file b/lib/redmine/helpers/gantt.rb.rej

patching file b/lib/redmine/helpers/gantt.rb

Hunk #1 FAILED at 687.

1 out of 1 hunk FAILED -- saving rejects to file b/lib/redmine/helpers/gantt.rb.rej

patching file b/lib/redmine/helpers/gantt.rb

Hunk #1 FAILED at 686.

1 out of 1 hunk FAILED -- saving rejects to file b/lib/redmine/helpers/gantt.rb.rej

patching file b/lib/redmine/helpers/gantt.rb

Hunk #1 FAILED at 220.

Hunk #2 FAILED at 694.

2 out of 2 hunks FAILED -- saving rejects to file b/lib/redmine/helpers/gantt.rb.rej

 Some help please ?

Thanks.

Version Info :

Environment:

Redmine version                          2.3.0.devel.11744

Ruby version                             1.8.7 (x86_64-linux)

Rails version                            3.2.13

Environment                              production

Database adapter                         MySQL

Redmine plugins:

due_date_reminder                        0.3.1

#29 - 2013-05-01 17:26 - Toshi MARUYAMA

David Dupont wrote:

Some help please ?

 Use -p1 instead of -p0.

patch -p1 < gantt-sort-trunk-r11744.diff

 And this patch is for trunk r11744, not 2.3.0.

#30 - 2013-05-02 12:22 - David Dupont

Thanks for the answer !

So i can't install it ?

2025-05-17 5/8

https://www.redmine.org/attachments/9596
https://www.redmine.org/attachments/9596
https://www.redmine.org/projects/redmine/repository/svn/revisions/11744
https://www.redmine.org/projects/redmine/repository/svn/revisions/11744


Even if i change the file manually ? Is there too many difference between the trunk and 2.3.0 ?

#31 - 2013-05-03 00:55 - Toshi MARUYAMA

David Dupont wrote:

Is there too many difference between the trunk and 2.3.0 ?

 There is no difference between trunk r11768 and 2.3-stable r11769 for this patch.

You can apply this patch to 2.3-stable.

#32 - 2013-05-18 01:36 - Toshi MARUYAMA

- File gantt-sort-trunk-r11856.diff added

This is patch for trunk.

There is no logic change from note-26 patch.

#33 - 2013-05-21 16:02 - Toshi MARUYAMA

- Target version set to 2.4.0

- % Done changed from 0 to 100

#34 - 2013-07-02 08:31 - Toshi MARUYAMA

- Related to Defect #7579: Gantt tab gives internal error. added

#35 - 2013-07-08 05:31 - Toshi MARUYAMA

- Related to Feature #14397: Gantt sorting as a configurable setting added

#36 - 2013-07-15 19:10 - Filou Centrinov

- File gantt-sort-version-trunk-r11898.diff added

Please correct sort_version_logic(). Only "version.effective_date" contains the start date of a version. Otherwise the versions won't sorted by start

date as expected.

#37 - 2013-07-19 13:32 - Filou Centrinov

- % Done changed from 100 to 90

#38 - 2013-08-14 04:56 - Mischa The Evil

- Assignee set to Toshi MARUYAMA

Filou Centrinov wrote:

Please correct sort_version_logic(). Only "version.effective_date" contains the start date of a version. Otherwise the versions won't sorted by

start date as expected.

 Toshi, can you look into this? Seems there might be something wrong with the tests because this does not trigger test failures.

#39 - 2013-10-13 10:02 - Jean-Philippe Lang

- Target version changed from 2.4.0 to Candidate for next major release

2.4 feature freeze

#40 - 2013-10-13 10:24 - Toshi MARUYAMA

- Target version changed from Candidate for next major release to 2.4.0

I think note 36 patch need to check in 2.4.0.

#41 - 2013-10-14 18:44 - Jean-Philippe Lang

Filou Centrinov wrote:

Please correct sort_version_logic(). Only "version.effective_date" contains the start date of a version. Otherwise the versions won't sorted by
start date as expected.

 A better option would be to sort versions by version.effective_date || version.start_date. A version may not have an effective_date but some issues

with start dates assigned to it.

Versions with no start_date nor effective should be listed at the very end. I'm not this is the case with || Date.new.

#42 - 2013-10-16 08:51 - Etienne Massip

If it can help, here's an excerpt from #7456 where the idea was also to display shared version before concerned projects:

The shared version is tied to the selected project (also valid for "all projects" Gantt):

parent project -> shared version -> subproject -> shared version issues (including parent project issues)

 The shared version is tied to a not-visible-parent project of the selected project:

subproject -> shared version  -> shared version issues (excluding parent project issues)

 Issue sorting code within a version+project scope:

      # Compare issues for rendering order 

      def gantt_issue_compare(x, y)

        if x.parent_id == y.parent_id

          # Same level in issue hierarchy

          basic_gantt_issue_compare(x, y)

        elsif x.root_id == y.root_id || x.root_id == y.id || y.root_id == x.id

          # Same issue hierarchy

          x.lft <=> y.lft

        else

          # Distinct hierarchies

          x.root_id <=> y.root_id

          # TODO : advanced sort between issues when ancestors have been filtered out by query

        end

      end

      def basic_gantt_issue_compare(x, y)

        if x.start_date == y.start_date

          x.id <=> y.id

        elsif x.start_date.nil?

          1 # null date appears at the end

        elsif y.start_date.nil?

          -1

        else

          x.start_date <=> y.start_date

        end

      end

#43 - 2013-11-09 09:56 - Jean-Philippe Lang

- Subject changed from Sorting issues in new gantt (v1.1.0) to Sorting issues in gantt by date, not by id

- Status changed from New to Closed

- Resolution set to Fixed

Toshi MARUYAMA wrote:

I think note 36 patch need to check in 2.4.0.

 Versions are now sorted by effective_date (r12247).

Files

sort_issues_from_start_date.diff 1.55 KB 2011-12-05 Felipe Ribeiro

sort_issues.rb 782 Bytes 2011-12-05 Felipe Ribeiro

redmine-trunk-r10713.png 21.5 KB 2012-10-24 Toshi MARUYAMA

redmine-trunk-r10713-patch.png 39.6 KB 2012-10-24 Toshi MARUYAMA

gantt-sort-r10713.diff 1.16 KB 2012-10-24 Toshi MARUYAMA

gantt-sort-trunk-r11692.diff 1.78 KB 2013-03-31 Toshi MARUYAMA

gantt-sort-trunk-r11692.png 20 KB 2013-03-31 Toshi MARUYAMA
gantt-sort-trunk-r11723.diff 3.12 KB 2013-04-19 Toshi MARUYAMA

gantt.jpg 65.4 KB 2013-04-22 Yuhki ISHIGURO

gantt-sort-trunk-r11740.diff 3.09 KB 2013-04-22 Toshi MARUYAMA

gantt-sort-trunk-r11744.diff 4.04 KB 2013-04-23 Toshi MARUYAMA

gantt-sort-trunk-r11856.diff 2.34 KB 2013-05-17 Toshi MARUYAMA

gantt-sort-version-trunk-r11898.diff 438 Bytes 2013-07-15 Filou Centrinov
